void SetFeatSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i;
	static int ClassPosition[128];
	static int MultiPos, name, epic, valcount, reqpos, skillpos, deppos, scriptpos, attackdeppos, feattypepos;
	static int TextPos, InbornPos, RelPos, StandardPos;

	char* TempPos;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number);
		}
		MultiPos = GetValNumber(Vals, "Multi", Number);
		epic = GetValNumber(Vals, "Epic", Number);
		name = GetValNumber(Vals, "Name", Number);
		reqpos = GetValNumber(Vals, "Req", Number);
		skillpos = GetValNumber(Vals, "SkillReq", Number);
		deppos = GetValNumber(Vals, "Dep", Number);
		scriptpos = GetValNumber(Vals, "EffectScript", Number);
		attackdeppos = GetValNumber(Vals, "AttackDep", Number);
		feattypepos = GetValNumber(Vals, "FeatType", Number);
		TextPos = GetValNumber(Vals, "Text", Number);
		InbornPos = GetValNumber(Vals, "Inborn", Number);
		RelPos = GetValNumber(Vals, "Rel", Number);
		StandardPos = GetValNumber(Vals, "Standard", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in FeatSource Database\n");
		quitprog();
	}
	
	((clsFeatSource*) TargetStruct)->Name = Vals[name];

	((clsFeatSource*) TargetStruct)->Probability = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetFeatSource-Probability");
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		((clsFeatSource*) TargetStruct)->Probability[i] = atoi(Vals[ClassPosition[i]]);
	}
	((clsFeatSource*) TargetStruct)->MultipleTimes = atoi(Vals[MultiPos]);
	((clsFeatSource*) TargetStruct)->Epic = atoi(Vals[epic]);
	((clsFeatSource*) TargetStruct)->DepType = atoi(Vals[deppos]);
	((clsFeatSource*) TargetStruct)->FeatType = atoi(Vals[feattypepos]);


	((clsFeatSource*) TargetStruct)->Inborn = atoi(Vals[InbornPos]);
	((clsFeatSource*) TargetStruct)->Standard = atoi(Vals[StandardPos]);

	((clsFeatSource*) TargetStruct)->RelCount = 0;
	if (strlen(Vals[RelPos]) > 1)
	{
		((clsFeatSource*) TargetStruct)->Rel = (int*) mallocl(substr_count(asc(";"), Vals[RelPos]) * sizeof(int), "SetFeatSource-Rel");
		str_replace(asc(";"), 0, Vals[RelPos]);
		TempPos = Vals[RelPos];
		while (*TempPos)
		{
			((clsFeatSource*) TargetStruct)->Rel[((clsFeatSource*) TargetStruct)->RelCount] = GetRegionNumber(TempPos);
			((clsFeatSource*) TargetStruct)->RelCount++;
			TempPos += strlen(TempPos) + 1;
		}
	}

	((clsFeatSource*) TargetStruct)->Text = Vals[TextPos];
	str_replace(asc("_"), asc(" "), ((clsFeatSource*) TargetStruct)->Text.buffer);

	((clsFeatSource*) TargetStruct)->ReqStr = Vals[reqpos];
	((clsFeatSource*) TargetStruct)->SkillStr = Vals[skillpos];

	str_replace(asc(","), asc(" "), ((clsFeatSource*) TargetStruct)->ReqStr.buffer);
	str_replace(asc(";"), 0, ((clsFeatSource*) TargetStruct)->ReqStr.buffer);

	str_replace(asc(","), asc(" "), ((clsFeatSource*) TargetStruct)->SkillStr.buffer);
	str_replace(asc(";"), 0, ((clsFeatSource*) TargetStruct)->SkillStr.buffer);

	((clsFeatSource*) TargetStruct)->AttackDep = atoi(Vals[attackdeppos]);

	if (bnf::bnfparse(Vals[scriptpos], &(((clsFeatSource*) TargetStruct)->Script)))
	{
		printf("Error in Feat Script %s\n", Vals[name]);
		quitprog();
	}
}

int GetFeatNumber(char* FeatName, int uncomplete = 0)
{
	int i;
	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		if (Source.FeatSource[i].Name == FeatName)
		{
			return(i);
		}
		if (uncomplete == 1 && strstr(Source.FeatSource[i].Name, FeatName) != 0)
		{
			return(i);
		}
	}
	printf("Feat not found(%s)\n", FeatName);
	quitprog();
	return(0);
}

void FeatSourceExit()
{
	int i;
	for (i = 0;i < Source.FeatSourceCount;i++)
	{
		freel(Source.FeatSource[i].Script);
		freel(Source.FeatSource[i].Probability);
		if (Source.FeatSource[i].RelCount)
		{
			freel(Source.FeatSource[i].Rel);
		}
	}
	delete[] Source.FeatSource;
}
